//=============================================================================
// LController. Made by Alpha ~ http://www.dxalpha.co.uk
//=============================================================================
class LController extends Actor;

var LKeypad Keypad;
var DeusExPlayer Player;
var LHUDKeypadWindow _keypadWindow;
var int passLength;
var sound successSound;
var sound failureSound;

replication
{
  reliable if(Role == ROLE_Authority) // send to client
    _ActivateWindow, _setStatus, passLength, successSound, failureSound;

  reliable if(ROLE < ROLE_Authority) // receive from client
    _validateCode;
}

function Activate()
{
  // Following two if statements should be impossible
  // But check for them anyways
  if(Player == None || Keypad == None)
    return;

  if(Owner != Player)
    SetOwner(Player);

  _ActivateWindow(Player);
}

function Deactivate()
{
  Destroy();
}

simulated function _ActivateWindow(DeusExPlayer Hacker)
{
  local DeusExRootWindow root;

  if(Hacker == None)
    return;

  root = DeusExRootWindow(Hacker.rootWindow);
  if (root != None)
  {
    _keypadWindow = LHUDKeypadWindow(root.InvokeUIScreen(Class'LHUDKeypadWindow', True));
    root.MaskBackground(True);
    if (_keypadWindow != None)
    {
      _keypadWindow.keypadOwnerL = Self;
      _keypadWindow.player = Hacker;
      _keypadWindow.InitData();
    }
  }
}

simulated function _setStatus(int newStatus)
{
  if(_keypadWindow == None)
    return;

  _keypadWindow.SetStatus(newStatus);
}

function _validateCode(string inputCode)
{
  if(Keypad == None || Player == None)
    return;

  if(inputCode == Keypad.validCode)
  {
    _setStatus(1);
    runKeypad(1);
  }
  else
  {
    _setStatus(0);
    runKeypad(0);
  }
}

function runKeypad(int runMode)
{
  if(Keypad == None || Player == None)
    return;

  if(runMode == 1)
  {
    if(Keypad.Event != '')
    {
      if(Keypad.bToggleLock)
      {
            ToggleLocks();
      }
      else
      {
            RunEvents(True);
      }
    }
    RunUntriggers();
  }
  else
  {
    if(Keypad.FailEvent != '')      
      RunEvents(False);
  }
}

function RunUntriggers()
{
  local Actor A;
  local int i;

  if(Keypad == None || Player == None)
    return;

  for(i=0; i < ArrayCount(Keypad.UnTriggerEvent); i++)
  {
    if(Keypad.UnTriggerEvent[i] != '')
    {
      foreach AllActors(class 'Actor', A, Keypad.UnTriggerEvent[i])
      {
        A.UnTrigger(Self, Player);
      }
    }
  }
}

function RunEvents(bool bSuccess)
{
  local Actor A;

  if(Keypad == None || Player == None)
    return;

  if((bSuccess) && (Keypad.Event != ''))
  {
    foreach AllActors(class 'Actor', A, Keypad.Event)
      A.Trigger(Self, Player);
  }
  else if((!bSuccess) && (Keypad.FailEvent != ''))
  {
    foreach AllActors(class 'Actor', A, Keypad.FailEvent)
      A.Trigger(Self, Player);
  }
}

function ToggleLocks()
{
  local Actor A;

  if(Keypad == None || Player == None)
    return;

  if(Keypad.bToggleLock)
  {
    foreach AllActors(class 'Actor', A, Event)
      if(A.IsA('DeusExMover'))
        DeusExMover(A).bLocked = !DeusExMover(A).bLocked;
  }
}

defaultproperties
{
  bHidden=True
}
