//=============================================================================
// LKeypad. Made by Alpha ~ http://www.dxalpha.co.uk
//=============================================================================
class LKeypad extends HackableDevices abstract;

var(Keypad) string validCode;
var(Keypad) sound successSound;
var(Keypad) sound failureSound;
var(Keypad) name FailEvent;
var(Keypad) bool bToggleLock;

function HackAction(Actor Hacker, bool bHacked)
{
  local DeusExPlayer Player;

  Player = DeusExPlayer(Hacker);

  if(Player != None)
  {
    activateKeypad(Player);
  }
}

function activateKeypad(DeusExPlayer Player)
{
  local LController Controller;

  if(Player == None)
    return;

  Controller = Spawn(Class'LController');
  if(Controller != None)
  {
    Controller.successSound = successSound;
    Controller.failureSound = failureSound;
    Controller.passLength = Len(validCode);
    Controller.SetOwner(Player);
    Controller.Keypad = self;
    Controller.Player = Player;
    Controller.Activate();
  }
}

defaultproperties
{
  bHackable=False
  validCode="1234"
  successSound=Sound'DeusExSounds.Generic.Beep2'
  failureSound=Sound'DeusExSounds.Generic.Buzz1'
  bToggleLock=True
  ItemName="Security Keypad"
  Mass=10.00
  Buoyancy=5.00
}
